from rocolib.api.components import FoldedComponent
from rocolib.api.composables.graph.Face import Rectangle, Face

class TwoDOF(FoldedComponent):
  def define(self):
    self.addParameter("mountlength", 40, paramType="length")
    self.addParameter("handlelength", 15, paramType="length")
    self.addParameter("thickness", 10, paramType="length")
    self.addParameter("pitch", 135, paramType="angle")
    self.addParameter("yaw", 60, paramType="angle")

    self.addEdgeInterface("mountedge", "mount.e0", "width")
    self.addEdgeInterface("oaredge", "r2.e2", "h")

  def assemble(self):
    t = self.p.thickness
    w = self.p.mountlength
    h = self.p.handlelength
    p = self.p.pitch
    y = self.p.yaw

    b = Face("", ((w, 0), (w, t), (w/2,t), (0,t), (0,0)))
    b0 = Rectangle("", w, 0)
    r1 = Rectangle("", w/2, t)
    r2 = Rectangle("", h, t)

    self.addFace(b, "base")
    self.attachEdge("base.e2", r1, "e0", prefix="r1", angle=-180)
    self.attachEdge("r1.e3", r2, "e1", prefix="r2", angle=y)
    self.attachEdge("base.e0", b0, "e2", prefix="mount", angle=p)

if __name__ == "__main__":
    TwoDOF.test()
