from rocolib.api.components import FoldedComponent
from rocolib.api.composables.graph.Face import RegularNGon2 as Shape
from rocolib.utils.transforms import Translate


class TwoNGons(FoldedComponent):
  def define(self):
    self.addParameter("n1", 5, valueType="int", minValue=3)
    self.addParameter("n2", 3, valueType="int", minValue=3)
    self.addParameter("d", 10, paramType="length")
    self.addParameter("radius", 25, paramType="length")

  def assemble(self):
    self.addFace(Shape("", self.p.n1, self.p.radius), "r1")
    self.attachFace("r1", Shape("", self.p.n2, self.p.radius), "r2", Translate([0,0,self.p.d]))

if __name__ == "__main__":
    TwoNGons.test()
